<%
	/*
	 * ============================================================================
	 * Licensed Materials - Property of IBM
	 *  WebSphere sMash
	 *
	 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
	 *
	 * US Government Users Restricted Rights - Use, duplication or disclosure
	 * restricted by GSA ADP Schedule Contract with IBM Corp.
	 * ============================================================================
	 */


	import zero.appbuilder.JavaScriptUtils;
	
	def requires = JavaScriptUtils.readProfileDependencies();
	def size = requires.size();

	println();
	for (i=0; i<size; i++) {
		String temp = requires.get(i);
		// TODO: Figure out why these exceptions will not load with dojo.require
		if (temp.indexOf("common.") == -1 && 
			temp.indexOf("rt_console") == -1 &&
			temp.indexOf(".repository") == -1) 
		{
			println("\t\tdojo.require(\"${temp}\");");
		}
	}
	
	println("\t\tdojo.require(\"dojo.parser\");");
	
%>
		
var mController;
var handleInitParms = null;
var handleInitParmsWasSet = false;
var currentApplication = null;
var cleaningup = false;
var indexRestoringState = false;
var autoShowConsoleWindow = false;
var userSettings = null;
var sortdir = "ASC";
		
function resize() {
	if (this.showingMgrView) {
		dijit.byId('app-mgr-ui-id').resize();
	} else {
		//dijit.byId('app-edit-ui-id').resize();
	}
	if(zlog.isDebug())console.debug('index.html: Window resized event fired!');
} 
		
dojo.connect(window, 'resize', this, 'resize');

function hideLoader()
{
    var loader = dojo.byId('loader'); 
    dojo.fadeOut({ node: loader, duration:500,
        onEnd: function(){ 
            loader.style.display = "none"; 
        }
    }).play();
}
        
        function init()
{	
		    if (!this.objectConnections) {
		        this.objectConnections = [];
	            this.objectConnections[0] = dojo.subscribe("ShowView", "_showView");
		    }

            var forms = dijit.byId('mgrcoreIde');
            // forms.setRunButton(dijit.byId('runButton'));
	
		
            mController = new zero.ide.controllers.AppUiController();
            mController.setIdeWidget(forms);
            
            var manager = dijit.byId('app-mgr-ui-id');
            manager.setController(mController);
            manager.setIdeWidget(forms);
//            dojo.connect(manager, 'showEditor', showEditor);
           
		   loadUserSettings();
		    
		   var loc =  window.location.toString();
		   loc = decodeURIComponent(loc);   
           showManager(true);
        }
 

        function setFooterDisplay()  // Lotus footer window based on preference. i.e.,  expanded or collaped
        {
		  if ( userSettings.footerCollapsed ){
		      this.footerToggle();//minimize it
		  }
		} 

        function cleanup()  // ELC do cleanup here
        {
		  this.cleaningup = true;
        } 
		
		function loadUserSettings () {			               
            dojo.xhrGet({url: 'resources/settings',
            	load: dojo.hitch(this, 
					 					function(response, ioArgs)
										{
											userSettings = response;
		                                    //set footer window expanded or collapsed based on last accessed  
		                                    this.setFooterDisplay();
										
											if(zlog.isDebug())console.debug("defaultPath="+userSettings.defaultPath);
											if(zlog.isDebug())console.debug("fileSeparator="+userSettings.fileSeparator);
										}),
                error: dojo.hitch(this, 
                                       function(response, ioArgs)
                                       {
                                            var messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "AppMgrUiNls");                                       
                                            dijit.byId('status-dialog').showDialog('Error', '',
                                                                          dojo.string.substitute(messages.error_loading_user_settings) + ' ' + eval('(' + ioArgs.xhr.responseText + ')').errorMessage);
											return response;																		  
                                       }),                  
				preventCache: true,
				handleAs: "json"					 
			});        
		}	
		
		function setDefaultPath(newDefaultPath) {			
			if(zlog.isDebug())console.debug("setDefaultpath="+ newDefaultPath );
			
			// Always update in case of multiple browser sessions
			
			userSettings.defaultPath = newDefaultPath;
        
			var bindArgs = {
			        url: 'resources/settings/defaultPath',
		        	contentType: "text/json-comment-filtered",
			        load: dojo.hitch(this, function(response, args) {
							// No real action to take
							if(zlog.isDebug())console.debug("settings/defaultPath updated")	
							return response;
			        }),
			        error: dojo.hitch(this, function(type, error) {
							console.log("A problem occurred while trying to write user settings");
					}),
			        putData : dojo.toJson(newDefaultPath),
			        handleAs: "text"        
			  };
			
			  var request = dojo.rawXhrPut(bindArgs);			
		}
		
		function parseInitParm(loc, key) {
		   if(zlog.isDebug())console.debug('index.html parseInitParm key = '+key +' loc = ' + loc );

			var ret = null;
			var ind = loc.indexOf(key+'=');
 		    if (ind >= 0) {
			   var l2 = ind+key.length+1;
			   if (loc.indexOf('+') > 0) {	 
			     ret = loc.substring(l2,loc.indexOf('+'));
			   } else {
			   	 ret = loc.substring(l2,loc.length);
			   }
			   if(zlog.isDebug())console.debug('index.html parseInitParm key = '+key +' ret = ' + ret );
			} 
			return ret;           
        }	

		

		var HistoryTracker = function(view, app, uiview, file, appName){ 
		    this.histcount = this.histcount++;
			this._view = view;
			this._app = app;
            this._uiview = uiview;
            this._file = file;
			this._appName = appName;
		    this.dispViewMsgs = { 
			       allFilesView:"File editor",
				   depView:"Dependencies",
				   commandView:"Command",
                   consoleView:"Console",				   
				   exploreView: "Explore"
			};
									
		    var url = "view="+view;
		    if (app !== null && app !== undefined) {
		       url = url + "+app="+app;
		    }
		    if (uiview !== null && uiview !== undefined) {
		       url = url + "+uiview="+uiview;
		    }
		    if (file !== null && file !== undefined) {
		       url = url + "+file="+file;
		    }
			setTitle(this);

			
		    if(zlog.isDebug())console.debug("in HistoryTracker ENTRY/EXIT url = "+url);
		    if(zlog.isDebug())console.debug("in HistoryTracker ENTRY/EXIT handleInitParms  ");
			if(zlog.isDebug())console.debug(handleInitParms);
		        
			this.changeUrl = url;
			
			
		};    
			
			        
		function setTitle(histTracker) {
           if(zlog.isDebug())console.debug("in setTitle histTracker = ");
		   if(zlog.isDebug())console.debug(histTracker);
		   var view = histTracker._view;
		   var app = histTracker._app;
           var uiview = histTracker._uiview;
           var file = histTracker._file;
		   var appName = histTracker._appName;
		    this.dispViewMsgs = { 
			       allFilesView:"File editor",
				   depView:"Dependencies",
                   commandView:"Command",				   
                   consoleView:"Console",				   
				   exploreView: "Explore"
			};

			var title = "Zero Admin";
			if (view === "AppManager") {
				title = "My Applications - "+title;
   		        var node = dojo.byId("lotusLogo");
				if ( node ){
                  node.ownerDocument.title = title;
				} 
			} else if (view === "RepoManager") {
				title = "My Repository - "+title;
   		        var node = dojo.byId("lotusLogo");
				if ( node ){
                  node.ownerDocument.title = title;
				} 
			} else { 
			   if (appName !== null && appName !== undefined) {
					   if (file !== null && file !== undefined) {
				          title = appName+" ("+file+") - "+title;
				       } else {
		 			      if (uiview !== null && uiview !== undefined) {
				               title = this.dispViewMsgs[uiview]+" - "+title;
				         }
		                 title = appName+" - "+title;
			           }

		   		       var node = dojo.byId("uilogo");
					   if ( node ){
                         node.ownerDocument.title = title;
					   } 
               } else { 
			    if (app !== null && app !== undefined) {
			   	  var foundapp = mController.findAppById(app);
				  if(zlog.isDebug())console.debug("foundapp is = ");
				  if(zlog.isDebug())console.debug(foundapp);
				  if (foundapp !== null) {
		               //title = "App: "+foundapp.name+" - "+title;
					   if (file !== null && file !== undefined) {
				          title = foundapp.name+" ("+file+") - "+title;
				          //title = "File: "+file+" - "+title;
				       } else {
		 			      if (uiview !== null && uiview !== undefined) {
				             title = uiview+" - "+title;
				         }
		                 title = foundapp.name+" - "+title;
			           }
		   		       var node = dojo.byId("uilogo");
					   if ( node ){
                          node.ownerDocument.title = title;
					   } 
				  }
		        }
			   }
			}
		   
        }	
	
		dojo.extend(HistoryTracker, {
			back: function(){
		    if(zlog.isDebug())console.debug("in HistoryTracker.prototype.back going back to "+this._view);
			_restoringState = true;

			indexRestoringState = true;
		    //alert("in HistoryTracker.prototype.back setting  indexRestoringState="+indexRestoringState);		  
		    
		    if (this._view == "AppEditor" && currentApplication == null) {
				 // need to setup current application for edit
				 handleInitParms = this;
				 mController.findAndOpenApp(handleInitParms);
			} else {	
			   dojo.publish("ShowView", [{source: this }]);
			} 
			setTitle(this);
			_restoringState = false;            
		  },
		
		forward: function(){
		    if(zlog.isDebug())console.debug("in HistoryTracker.prototype.forward going forward to "+this._view);	
			_restoringState = true;			
			indexRestoringState = true;
		    //alert("in HistoryTracker.prototype.forward setting  indexRestoringState="+indexRestoringState);		  

		    if (this._view == "AppEditor" && currentApplication == null) {
				 // need to setup current application for edit
				 handleInitParms = this;
				 mController.findAndOpenApp(handleInitParms);
			} else {	
			   dojo.publish("ShowView", [{source: this }]);
			} 

			setTitle(this);
			_restoringState = false;   

		}
		});
		
		
					
		function shouldChangeUrl(){
				return true;
		}

		
        
        function showEditor()
        {
			showManager(false);
        }
        
        function cancelClicked()
        {
            showManager(true);
//djb[03/26/2008]		    dojo.byId("logo").innerHTML = "Welcome to the App Builder";
			var ban = dijit.byId("banner");
			ban.showMyApps();

        }

        
        function repoMgrClicked()
        {
        	// TODO: There's a race condition here between the repository show and
        	// the callback that occurs when manager refresh completes.  The skipRefresh 
        	// argument on showManager is an attempt to avoid it.
			if(zlog.isDebug())console.debug(" in repoMgrClicked --------------------- ");
            showManager(true,true);
			var ban = dijit.byId("banner");
			ban.showMyRepository();
        }

        
		function _showView(msg)
        {
			if(zlog.isDebug())console.debug("in _showView with msg = ");
			if(zlog.isDebug())console.debug(msg.source);
			if(zlog.isDebug())console.debug(msg.source._view);
	        this._restoringState = true;			 
	
			var view = msg.source._view;
			
		    if (view !== null && view !== undefined) {
			   if (view !== "AppEditor") {
//djb[03/26/2008]		          dojo.byId("logo").innerHTML = "Welcome to the App Builder";
				  var ban = dijit.byId("banner");
                  ban.restoringState = true;
			      if (view === "RepoManager") {
					showManager(true,true);
						ban.showMyRepository(true); // true for restoringState
				  } else {
					showManager(true);
						ban.showMyApps(true);  // true for restoringState
				  }	
                  ban.restoringState = false;
			   } else {
			   	  if (this.showingMgrView) {
				  	if(zlog.isDebug())console.debug("in index.html _showView calling showManager(false)");
	                 showManager(false);
				  }
			   }	
	        } else {
				showManager(true);
			}
	        this._restoringState = false;
			indexRestoringState = false;
					
	    }
		
        function showManager(pManagerOrEditor, skipRefresh)
        {
			if(zlog.isDebug())console.debug("showManager called with "+pManagerOrEditor);
            hideLoader();
            
			if (!this._restoringState && pManagerOrEditor && handleInitParms !== null) {
				 //dojo.back.addToHistory(new HistoryTracker('AppManager', null, null, null, null));
            }
			this.showingMgrView = pManagerOrEditor; 
            dijit.byId('app-mgr-ui-id').domNode.style.display = pManagerOrEditor ?
                                                                    'block' : 'none';
            //dijit.byId('app-edit-ui-id').domNode.style.display = pManagerOrEditor ?
            //                                                        'none' : 'block';
            
            if (pManagerOrEditor)
            {
				currentApplication = null;
				// Show the manager
				mController.setStatusHidden();
            }
            else
            {
				// Show the editor
				if (handleInitParms !== null) {
					if(zlog.isDebug())console.debug("in showManager handleInitParms = ");
					if(zlog.isDebug())console.debug(handleInitParms);
					//ELC need to get the app info and call open and publish...
					mController.findAndOpenApp(handleInitParms);
					handleInitParms = null;
				} else {
				   if (currentApplication !== null) {
				      mController.updateApplicationStatus();
				   }
				}							 
            }
            
			var manager = dijit.byId('app-mgr-ui-id');
			// Refresh the list of applications if in App Mgr mode
			if (pManagerOrEditor && skipRefresh != true) {
				manager.refresh();
			}
			resize();
        }

		function showSamples() {
			var mgr = dijit.byId('app-mgr-ui-id');
			mgr.showSamples();
		}
		
		function footerToggle() {
			var footerIcon = dojo.byId("lotusFooterIcon");
			if (dojo.hasClass(footerIcon, "footerCloseIcon")) {
				dojo.removeClass(footerIcon, "footerCloseIcon");
				dojo.addClass(footerIcon, "footerOpenIcon");
				dojo.addClass("lotusFooter", "footerClosed");
				this.saveFooterPreference(true);//footer window is being collapsed					
			} else {
				dojo.removeClass(footerIcon, "footerOpenIcon");
				dojo.addClass(footerIcon, "footerCloseIcon");
				dojo.removeClass("lotusFooter", "footerClosed");					
				this.saveFooterPreference(false); //footer window is being expanded
			}
			resize();
		}

		function saveFooterPreference(collapseFooterWindow) {			
			if(zlog.isDebug())console.debug("in saveFooterPreference: collapseFooterWindow="+ collapseFooterWindow );
			
			//update preference if they are different
			if ( userSettings.footerCollapsed == collapseFooterWindow){
				return;//nothing to update; already in the correct state
			}
			userSettings.footerCollapsed = collapseFooterWindow;
        
			var bindArgs = {
			        url: 'resources/settings/footerCollapsed',
		        	contentType: "text/json-comment-filtered",
			        load: dojo.hitch(this, function(response, args) {
							// No real action to take
							if(zlog.isDebug())console.debug("settings/footerCollapsed updated");	
							return response;
			        }),
			        error: dojo.hitch(this, function(type, error) {
							// can't set prefernce....keep the default in place.
							if(zlog.isDebug())console.debug("saveFooterPreference(): A problem occurred while trying to write user settings");	
					}),
			        putData : dojo.toJson(userSettings.footerCollapsed),
			        handleAs: "text"        
			  };
			
			  var request = dojo.rawXhrPut(bindArgs);			
		}
       
	    function newWindowMenu(evt) {
			//build up the URL to run in a seperate browser window
	   		var targetedUri = "";
		    
			//only interested in everything before #view and then we'll be rest of url...
	   		var loc = window.location.toString();
	   		var baseURI = decodeURIComponent(loc).split("#view=");
			var rightClickTargetID = evt._rightClickCurrentTarget.id;
			//encodeURIComponent
		    if (rightClickTargetID.indexOf('myappslink') > -1 ) {
		         //create url AppMgr page
		         targetedUri = baseURI[0] + '#' + encodeURIComponent('view=AppManager' );
			}else
			  if (rightClickTargetID.indexOf('myrepolink') > -1 ) {
		         //create url RepoMgr page
		         targetedUri = baseURI[0] + '#' + encodeURIComponent('view=RepoManager' );
			  }else{
                 //didn't find the target id, use the current url
		         targetedUri = loc; //use the same url to open a new window
			  }
	        //open new browser window or new window in a tab.  
	        openNewWindow(evt.currentTarget.sectionRowIndex==1,targetedUri);
		};
		
		function openNewWindow(/*boolean*/openWindowInTab, url) {
			//FF is good in opening in s new tab. Only this menu option is exposed in FF
		  var newwindow = null;
		  var width  = window.innerWidth;
		  var height = window.innerHeight;

		  if ( openWindowInTab ) {
		     newwindow = window.open(url, '_blank'); //open new window in browser tab
		  }else{//open new browser window
		     newwindow = window.open(url, '_blank','width='+width+',height='+height+
			   ',alwaysRaised=yes,scrollbars=yes,location=yes,directories=no,status=yes,menubar=yes,toolbar=yes,resizable=yes'); //open new instance of browser 		  	
		  }
		  if (window.focus) {
		  	 newwindow.focus()};
		}
        
		if(zlog.isDebug())console.debug("The current version of dojo is: " + dojo.version.toString());
		dojo.addOnUnload( this, "cleanup" );
        dojo.addOnLoad(this, "init");
