/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *  WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
if(!dojo._hasResource["zero.ide.widget.appmgr.AppMgrUi"]){
dojo._hasResource["zero.ide.widget.appmgr.AppMgrUi"] = true;
dojo.provide("zero.ide.widget.appmgr.AppMgrUi");
dojo.requireLocalization("zero.ide.widget.appmgr", "AppMgrUiNls");

// zero.admin specific code
dojo.require("zero.ide.widget.appmgr.AdminCoreIde");
dojo.require("zero.ide.widget.appmgr.AdminPageBanner");
// zero.admin specific code
dojo.require('zero.ide.widget.appmgr.BrowseApplicationsDialog');
dojo.require('zero.ide.widget.appmgr.DeleteAppDialog');

/* Not needed for Admin
dojo.require('zero.ide.widget.appmgr.CreateAppDialog');
dojo.require('zero.ide.widget.appmgr.CopyFromRepositoryDialog');
dojo.require('zero.ide.widget.appmgr.CopyMoveAppDialog');
dojo.require('zero.ide.widget.appmgr.PackageAppDialog');
*/
dojo.require('zero.ide.widget.appmgr.AppListRow');
dojo.require("zero.ide.widget.appmgr.FilteringFileComboBox");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");


dojo.declare('zero.ide.widget.appmgr.AppMgrUi',
             [dijit._Widget, dijit._Templated],
{
    widgetsInTemplate: true,
      templatePath: dojo.moduleUrl("zero","ide/widget/appmgr/templates/AppMgrUi.html"),


    _isEditing: false,
	admin: true,
    _contextMenuRow: -1,
    _controller: null,
	myListRowWidgets: [],

    //@BVT will substitute token e.g, something like http://www.projectzero.org/zero/silverstone/latest , it will change based on release level
    product_url: 'http://www.projectzero.org/sMash/1.1.x',  //showhelp() references this url   
    
	//dummy data
	datarow : {     //"module_group" : "experimental",
					"tags"         : "ZeroProject",
					"last_accessed": "March 19th, 2008" },

    //app_FilterDots  : "Filter...",
    //app_FilterTitle  : "Filter by name, path, description, module group and tags.",

	SORT_NAME : "name", // Sort by name
	SORT_PATH : "path", // Sort by path
	SORT_LASTACCESSED : "lastAccessed", // Sort by lastAccessed
	SORT_STATUS : "status", // Sort by status
	SORT_DESC : "DESC",     // Sort descending
	SORT_ASC : "ASC",      // Sort ascending

	messages:null,

    showDescription: "",

//    url:TEMPORARY_STORAGE_URL,
    url: null,
        
    newApplication: function()
    {
		if (zlog.isDebug())console.debug("newApplication");
        this.createAppDialog.setUpCreate();
		this.createAppDialog.show();
    },
   
    forceRefresh: function()
    {
		this.appListDirty = true;
		this.refresh();
	}, 
	
    refresh: function()
    {

        //check to see if "My Repository" is currently selected   
	    if (!this.admin && dojo.hasClass(dijit.byId('banner').myrepolinkLI,"lotusSelected")){
            //refresh My Repository page
			this.showMyRepository();
	    
		}else{//must be My App view list showing - myappslinkLI was set
            if (this.appListDirty) {
        		this._ideWidget.showProgressDlg(dojo.string.substitute(this.messages.loading_apps));
			}			
			// Retrive the list of My Applications
			currentApplication = null;
	        this._controller.retrieveAll();
			this.setAppAreaSize();        
		}
    },	
	
    _onMyAppsClick: function(pEvent)
    {
        /*var data = this.myAppsTable.getSelectedData();
        if (null !== data)
        {
            if(zlog.isDebug())console.debug(data.application); 
            this._controller.open(data.application);
        }
        */
    },
    
    itemEdit: function()
    {
/*        var data = this.myAppsTable.getSelectedData();
        if (null !== data)
        {
            this._controller.open(data.application);
        }
*/        
    },
    
    _applicationLoaded: function(pApplication)
    {
        this.showEditor();
    },
	

    browseApplications: function()
    {
		if(zlog.isDebug())console.debug(" in browseApplications");
		
        if (!this.fileSelectionConn) {
		  this.fileSelectionConn = dojo.connect(this.browseApplicationsDialog,'_fileSelected', this,'delayedRequestOpenApplication');
		}
		
        this.browseApplicationsDialog.setUpCreate();
		
		this.browseApplicationsDialog.show();	
    },	

    copyFromRepository: function()
    {
		if(zlog.isDebug())console.debug(" in copyFromRepository");
		
        if (!this.copyFromRepositoryConn) {
		  this.copyFromRepositoryConn = dojo.connect(this.copyFromRepositoryDialog,'_fileSelected', this,'delayedRequestCopyFromRepository');
		}
		
        this.copyFromRepositoryDialog.setUpCreate();
		
		this.copyFromRepositoryDialog.show();	
    },


    importApplication: function()
    {
		if(zlog.isDebug())console.debug(" in importApplication");
		
        // if (!this.importApplicationConn) {
		  // this.importApplicationConn = dojo.connect(this.importApplicationDialog,'_appImport', this,'delayedRequestImportApplication');
		  //  this.importApplicationConn = dojo.connect(this.importApplicationDialog,'_appImport', this,'delayedRequestImportApplication');
		// }
		
        this.importApplicationDialog.setUpCreate();
		
		this.importApplicationDialog.show();
			
    },
    
    copyApp: function(msg)
    {
	  // msg holds - pAction, appId, appName appPath	
		if(zlog.isDebug())console.debug(" in copyApp currentApp holds");
		if(zlog.isDebug())console.debug(msg);
		
        if (!this.copyAppConn) {
		  this.copyAppConn = dojo.connect(this.CopyMoveAppDialog,'_fileSelected', this,'delayedRequestMoveCopyApp');
		}
		this.CopyMoveAppDialog.currentApp = msg;
        this.CopyMoveAppDialog.setUpCreate();
		
		this.CopyMoveAppDialog.show();	
    },

    moveApp: function(msg)
    {
	  // msg holds - pAction, appId, appName appPath	
		if(zlog.isDebug())console.debug(" in moveApp currentApp holds");
		if(zlog.isDebug())console.debug(msg);
		
        if (!this.copyAppConn) {
		  this.copyAppConn = dojo.connect(this.CopyMoveAppDialog,'_fileSelected', this,'delayedRequestMoveCopyApp');
		}
		this.CopyMoveAppDialog.currentApp = msg;
        this.CopyMoveAppDialog.setUpCreate();
		
		this.CopyMoveAppDialog.show();	
    },

    exportApp: function(msg)
    {
	  // msg holds - pAction, appId, appName appPath	
		if(zlog.isDebug())console.debug(" in exportApp currentApp holds");
		if(zlog.isDebug())console.debug(msg);
		
        if (!this.exportAppConn) {
		  this.exportAppConn = dojo.connect(this.PackageAppDialog,'_fileSelected', this,'delayedRequestExportApp');
		}
		this.PackageAppDialog.currentApp = msg;
        //this.PackageAppDialog.setUpCreate();
		
		this.PackageAppDialog.show();	
    },


    showMyRepository: function()
    {
		if(zlog.isDebug())console.debug(" in showMyRepository ");
		dojo.style(this.welcomeText,"display","none");
        dojo.style(this.showMyApplications, "display", "none");
        dojo.style(this.actionsArea, "display", "none");
        dojo.style(this.appMgrTitleBarFilter, "display", "none");
        dojo.style(this.showMyRepo, "display", "block");

	    var elem = dojo.byId("appMgrTitleBar");
	    elem.innerHTML = "My Repository";

		
		var div = document.createElement("DIV");
    	this.mgrDepContent.setContent(div);
    	var mgr = new zero.ide.widget.dependency.RepositoryManager(
    		{
    			showProgress: dojo.hitch(this,this.showProgressDlg),
    			hideProgress: dojo.hitch(this,this.hideProgressDlg)
    		},div);
    	mgr.startup();


    },	

    showMyApps: function()
    {
		if(zlog.isDebug())console.debug(" in showMyApps ");
		dojo.style(this.welcomeText,"display","none");
        dojo.style(this.showMyRepo, "display", "none");
        dojo.style(this.showMyApplications, "display", "block");
        dojo.style(this.actionsArea, "display", "block");
        dojo.style(this.appMgrTitleBarFilter, "display", "block");

	    var elem = dojo.byId("appMgrTitleBar");
	    elem.innerHTML = "My Applications";

    },	

    
    itemExport: function()
    {
/*        var data = this.myAppsTable.getSelectedData();
        if (null !== data  &&  undefined !== data.application.editLink  &&
                    '' !== data.application.editLink)
        {
            alert('Exporting');
        }
*/        
    },
    
    itemLaunchApplication: function()
    {
/*        var data = this.myAppsTable.getSelectedData();
        if (null !== data)
        {
            this._controller.run(false, data.id);
        }
*/        
    },
    
    itemLaunchForm: function()
    {
/*        var data = this.myAppsTable.getSelectedData();
        if (null !== data)
        {
            this._controller.run(true, data.id);
        }
*/        
    },
    
//    itemPublish: function()
//    {
//        var data = this.myAppsTable.getSelectedData();
//        if (null !== data)
//        {
//            this._controller.publish(undefined, data.Id);
//        }
//    },
    
    itemRemove: function()
    {
/*        var data = this.myAppsTable.getSelectedData();
        if (null !== data)
        {
            this._controller.remove(data.id);
        }
*/        
    },
    
//    itemUnpublish: function()
//    {
//        var data = this.myAppsTable.getSelectedData();
//        if (null !== data)
//        {
//            this._controller.unpublish(data.Id);
//        }
//    },
    
    onOpenRemoveDialog: function()
    {
/*        var data = this.myAppsTable.getSelectedData();
        this.removeDialog.setName(data !== null ? data.application.name : "");
*/
        
    },
    
    _applicationCreated: function(pApplication)
    {
//        this.myAppsTable.store.addData(this._getMyAppsModel(pApplication));
    },
    
    _finishRefresh: function(pApplications)
    {
//        var myApps = [];
//        for (var i=0  ;  i < pApplications.length  ;  i++)
//        {			
//            myApps.push(this._getMyAppsModel(pApplications[i]));
//        }
        
/*        this.myAppsTable.store.clearData();
        this.myAppsTable.store.setData(myApps);
*/
          //done loading data
        if (!this.appListDirty && (pApplications.length !== this.sortData.length
		    || this.checkAppListDirty(pApplications))) {
			this.appListDirty = true;
		}
        
		if (pApplications.length !== 0) {
			dojo.style(this.welcomeText,"display","none");
			dojo.style(this.showMyApplications,"display","block");
		}
		else {
			dojo.style(this.welcomeText,"display","block");
			dojo.style(this.showMyApplications,"display","none");
		}

        if (this.appListDirty) {
		   if(zlog.isDebug())console.debug(" in AppMgrUi._finishRefresh appListDirty is true so call showNewList"); 	
	       //setup sort here
           this.sortData = pApplications.slice(); //clone app list
           if(zlog.isDebug())console.debug("appListSort data before sort this.sortKey = "+this.sortKey);
	       if(zlog.isDebug())console.debug(this.sortData);
           this.doSort();
		  
	       this.showNewList(this.sortData);	  
		   this.appListDirty = false;
		   this._ideWidget.hideProgressDlg();
		} else {
		   if (pApplications.length !== 0) {
		   	  for (var i = 0; i < pApplications.length; i++) {
				this._updateAppInfo(pApplications[i].id, pApplications[i]);
		   	  }
		   }
		}	

    },
    
    checkAppListDirty: function(pApplications)
    {
		var dirty = false;
		if (pApplications.length !== 0) {
		   	  for (var i = 0; i < pApplications.length; i++) {
			  	var idFound = false;
		   	    for (var j = 0; j < this.sortData.length; j++) {
				    if (pApplications[i].id == this.sortData[j].id) {
						idFound = true;
						break;
					}
				} 
				if (!idFound) {
				   return true;
				}
		   	  }
		}
        return false;
    },    
	
    _onMyAppsCellFilled: function(pCell, pCellIndex)
    {
        if (pCellIndex == 3)
        {
            // Setup DropDownMenu for My Applications table
            var parms =
            {
                label: "More Actions",
                dropDown: this.myAppsDropdownMenu
            };
            var widget = new dijit.form.DropDownButton(parms, pCell.firstChild);
        }
    },
    
    _finishRemove: function(pApplication)
    {
//        this.myAppsTable.store.removeDataByKey(pApplication.id);
    },
    
    _applicationUpdated: function(pApplication)
    {
/*        var data = this.myAppsTable.store.getDataByKey(pApplication.id);
        if (null != data)
        {
            this._getMyAppsModel(pApplication, data);
            this.myAppsTable.store.onSetData();
        }
*/        
    },
    
	_showAppStatus: function(appId, isRunning) 
	{
/*        var data = this.myAppsTable.store.getDataByKey(appId);
		data.application.isRunning = isRunning;
		if (isRunning)
			this.myAppsTable.store.update(data, 'status', '<img src="/zero/ide/images/running.gif" alt="running">');
		else
			this.myAppsTable.store.update(data, 'status', '<img src="/zero/ide/images/stopped.gif" alt="running">');		
*/	   
	    //update app status and icon in widget; stopped or started
		var appListRowWidget = dijit.byId("app-list-row-ui-" + appId);
        if ( appListRowWidget !== undefined && appListRowWidget !== null  ){
		    appListRowWidget.setAppStatus(isRunning);
		}
			
	},
    
	_updateAppInfo: function(appId, entry) 
	{
	    //update app status and icon in widget; stopped or started
		var appListRowWidget = dijit.byId("app-list-row-ui-" + appId);
        if ( appListRowWidget !== undefined && appListRowWidget !== null  ){
		    appListRowWidget.updateAppInfo(entry);
		}
			
	},


	setFocusToNewApp: function(newAppId) {
       if(zlog.isDebug())console.debug("AppListRow.setFocusToNewApp() newAppId = " + newAppId);
	   this.newAppId = newAppId;
    },
	
    _getMyAppsModel: function(pApplication, pObj)
    {
        if (undefined === pObj)
        {
            pObj = {};
        }
        
		if (pApplication.isRunning) 
        	pObj.status =  '<img src="/zero/ide/images/running.gif" alt="running">';
		else	
			pObj.status = '<img src="/zero/ide/images/stopped.gif" alt="running">';
		
        pObj.name = pApplication.name;
        pObj.description = pApplication.description;
        pObj.dropdown = '<div></div>';
        pObj.application = pApplication;
        pObj.id = pApplication.id;
         
        return pObj;
    },
    
    _onMyAppsDataToggled: function(pData)
    {
        //var isPublished = (pData ? pData.application.isPublished : false);
        this.myAppsLaunchItem.setDisabled(false);
        this.myAppsLaunchFormItem.setDisabled(false);
        //this.myAppsUnpublishItem.setDisabled(!isPublished);
    },
        
    setController: function(pController)
    {
        this._controller = pController;
        dojo.connect(this._controller, 'applicationCreated',
                         this, '_applicationCreated');
        dojo.connect(this._controller, 'applicationLoaded',
                         this, '_applicationLoaded');
        //dojo.connect(this._controller, 'applicationPublished',
        //                 this, '_applicationUpdated');
        dojo.connect(this._controller, 'applicationsRead',
                         this, '_finishRefresh');
        dojo.connect(this._controller, 'applicationRemoved',
                         this, '_finishRemove');
        dojo.connect(this._controller, 'applicationUpdated',
                         this, '_applicationUpdated');
		dojo.connect(this._controller, 'showAppStatus',
						 this, '_showAppStatus');					 
		dojo.connect(this._controller, 'updateAppInfo',
						 this, '_updateAppInfo');					 
    },
    
    _browseLinkClicked: function(pLinkWidget)
    {
        if(zlog.isDebug())console.debug("in AppMgrUi _browserLinkClicked pLinkWidget.text = "+pLinkWidget.text)

        if (pLinkWidget.text == this.messages.myrepositories ) {
			//ELC need to see if this is leaking since we don't destroy the prev widget
			var div = document.createElement("DIV");
	    	this.mgrDepContent.setContent(div);
	    	var mgr = new zero.ide.widget.dependency.RepositoryManager(
	    		{
	    			showProgress: dojo.hitch(this,this.showProgressDlg),
	    			hideProgress: dojo.hitch(this,this.hideProgressDlg)
	    		},div);
	    	mgr.startup();
			
			var createArea = dijit.byId('zero_ide_widget_appmgr_CommonLinkedContainerLinkGroup_1');		
            dojo.style(createArea.domNode, "display", "none");
		} else {
			var createArea = dijit.byId('zero_ide_widget_appmgr_CommonLinkedContainerLinkGroup_1');		
            dojo.style(createArea.domNode, "display", "block");
		} 
    },

	showProgressDlg: function(/*String*/msg, /* Function (optional) */ cancelCallback)
	{
		this._ideWidget.showProgressDlg(msg,cancelCallback);
	},

    hideProgressDlg: function()
    {
		this._ideWidget.hideProgressDlg();
    },

    findAppByNameAndPath: function(appName, appPath)
    {
		if(zlog.isDebug())console.debug("in AppMgrUi findAppByName appName ="+appName);
		if(zlog.isDebug())console.debug("in AppMgrUi findAppByName appPath ="+appPath);		
		var currentAppList = this._controller.currentApps;
		if(zlog.isDebug())console.debug(currentAppList);
        foundApp = null;
		if (currentAppList && currentAppList.length > 0) {
			for (var i=0  ;  i < currentAppList.length  ;  i++) {
				if (appName == currentAppList[i].name && appPath == currentAppList[i].path) {
					foundApp = currentAppList[i];
					break;
				}
			}
		}
		return foundApp;
			
    },        

    delayedRequestOpenApplication: function()
    {
    	this.browseApplicationsDialog.hide();

		var form = dijit.byId('fileSelectPathCombo');		
		
		var app = {
			name: "",
			path : "",
			existingApp: true
		};		
		// extract the name from the fq path
		var fqName = form.getValue(); 
		// The path may end with "/OpenedApp/", so strip off the ending /
		
		if (fqName.lastIndexOf(userSettings.fileSeparator) == (fqName.length-1)) {
			fqName = fqName.substring(0, fqName.length-1);
		}

		app.name = fqName.substring(fqName.lastIndexOf(userSettings.fileSeparator)+1);
		app.path = fqName.substring(0, fqName.lastIndexOf(userSettings.fileSeparator)+1);    
        if (app.path === null || app.path.length === 0){
			//error condition; combo store stored entry as invalid because didn't have ending '/'
			  //get the data from combo entry field
            fqName = this.browseApplicationsDialog.filePathCombo.textbox.value;
			app.name = fqName.substring(fqName.lastIndexOf(userSettings.fileSeparator)+1);
			app.path = fqName.substring(0, fqName.lastIndexOf(userSettings.fileSeparator)+1);
		}

        var appAlreadyInList = this.findAppByNameAndPath(app.name, app.path);        
        if (appAlreadyInList) {
			// this app is already in the list
        	var msg = dojo.string.substitute(this.messages.appAlreadyListed1) + app.name + dojo.string.substitute(this.messages.appAlreadyListed2);        	
			if (this._statusDialog) {
        		this.dlgConnection = dojo.connect(this._statusDialog, 'hideDialog', this, 'showDlgAfterAlreadyInListMsg');			   
				this._statusDialog.showDialog(this.messages.warning, "", msg);
			}
			this.setFocusToNewApp(appAlreadyInList.id);
        } else {

        	this._ideWidget.showProgressDlg(dojo.string.substitute(this.messages.opening_app));
			// set the default path to the path value specified on the open		
			setDefaultPath(app.path);		

	  		var paramsObj = {  
    	    	url: 'resources/applications',
        		sync: false,   
				postData: dojo.toJson(app),
	        	// preventCache: true,
		    	load: dojo.hitch(this, function(response, ioArgs) {   			    			
					this._ideWidget.hideProgressDlg();

					if (response.app && !response.app.isRunnable) {
				        var notRunnableDlg = dijit.byId('app-mgr-notrunnable-ui-id');
        	            notRunnableDlg._handleNotRunnableDetailsInfo(response, ioArgs);
/*
					var msg="";
					if (response.notRunnableDetail && (response.notRunnableDetail.length>0)) {
					    for (var j=0; j<response.notRunnableDetail.length; j++) {
				    	  msg += response.notRunnableDetail[j]+"<br>";
				   	    }				      
				    }
				    if (this._statusDialog) {
					   this._statusDialog.showDialog('Warning', 'The application was added, but it is not runnable.', msg);
				    }
*/
					}

			        this.setFocusToNewApp(response.app.id);
			        this.refresh();

		    	}),
        		error: dojo.hitch(this, function(type, ioArgs) {
					this._ideWidget.hideProgressDlg();
					if (this._statusDialog) {
				    	this._statusDialog.showDialog('Error', '', eval('(' + ioArgs.xhr.responseText + ')').errorMessage);
					}
				}),
        		contentType: "text/json-comment-filtered",
				mimetype: "text/json-comment-filtered",
        		handleAs: 'json'		
			};
			dojo.rawXhrPost(paramsObj);
        }
    },	

    showDlgAfterAlreadyInListMsg: function()
    {
		dojo.disconnect(this.dlgConnection);
		this.forceRefresh();
    },

    delayedRequestCopyFromRepository: function()
    {
		var app = {
			copyFrom : this.copyFromRepositoryDialog.getModule(),
			name : this.copyFromRepositoryDialog.getAppName(),
		    modulegroup:this.copyFromRepositoryDialog.getModuleGroup(),
			path : dijit.byId('copyFromRepoFileSelectCombo').textbox.value,
			linkTo : this.copyFromRepositoryDialog.getLinkToOption()
		};
        this.copyFromRepositoryDialog.hide();
        this._ideWidget.showProgressDlg(app.linkTo ? 'Linking module from repository' : 'Copying from repository');
		
		setDefaultPath(app.path);	
		this.copyFromRepositoryDialog.setLastModuleGroup();//save last selected item in combo

		
  		var paramsObj = {  
        	url: 'resources/applications',
        	sync: false,   
			postData: dojo.toJson(app),
        	// preventCache: true,
	    	load: dojo.hitch(this, function(response, ioArgs) {
				this._ideWidget.hideProgressDlg();
				var appModel = this._getMyAppsModel(response);											
				this._ideWidget.hideProgressDlg();
	    	    //console.dir(appModel);
				// Open the app
				//this._controller.open(appModel);
								
		        this.setFocusToNewApp(response.id);
		        this.refresh();
	    		
	    	}),
        	error: dojo.hitch(this, function(type, ioArgs) {
				this._ideWidget.hideProgressDlg();
				if (this._statusDialog) {
				   this._statusDialog.showDialog('Error', '', eval('(' + ioArgs.xhr.responseText + ')').errorMessage);
				}
				this.copyFromRepositoryDialog.show();

			}),
        	contentType: "text/json-comment-filtered",
			mimetype: "text/json-comment-filtered",
        	handleAs: 'json'		
		};		
		dojo.rawXhrPost(paramsObj);
    },

    
    delayedRequestImportApplication: function()
    {
        var theFormID="ApplicationImport";
        this.importApplicationDialog.hide();
        this._ideWidget.showProgressDlg('Importing Application');
        		
		var app = {
			path : dijit.byId('importFileSelectCombo').textbox.value
		};	
		setDefaultPath(app.path);
			
	   var bindArgs = {
		     url: "/appbuilder/importApplication.groovy" ,
	    	 form: theFormID,
	  		 method: "POST",
	   		 load: dojo.hitch(this,
                          function(response, ioargs) {
                              processUploadResult(response);
                          	  return response;
                         }),    
	    	 error: dojo.hitch(this,
                          function(response, ioargs) {
                              processUploadResult(response);
                          	  return response;
                          }),
        	 preventCache: true,
 	    	 handleAs: "text/html" //for multipart form, needed handleAs as text/html
		};
   
   		var request = dojo.io.iframe.send(bindArgs); //submits form with binding args
    },

    delayedRequestMoveCopyApp: function()
    {
		if(zlog.isDebug())console.debug(" in delayedRequestMoveCopyApp for copy, move or export currentApp holds");
		if(zlog.isDebug())console.debug(this.CopyMoveAppDialog.currentApp);

        this.CopyMoveAppDialog.hide();
		if (this.CopyMoveAppDialog.currentApp.pAction == "copy") {
			// msg holds - pAction, appId, appName appPath
          var toPath = this.CopyMoveAppDialog.filePathCombo.getValue();
		  this.doAppCopy();
	      //alert("Copy function is coming soon.... would copy "+this.CopyMoveAppDialog.currentApp.appName+" from path "+this.CopyMoveAppDialog.currentApp.appPath+ " To: "+toPath);
		} else if (this.CopyMoveAppDialog.currentApp.pAction == "move") {
          //var toMovePath = this.CopyMoveAppDialog.filePathCombo.getValue();
		  this.doAppMove();
		}  else if (this.CopyMoveAppDialog.currentApp.pAction == "export") {
		      if ( this.CopyMoveAppDialog.exportStandAloneCheckbox.checked ){
	            window.location.href="/resources/applications/"+this.CopyMoveAppDialog.currentApp.appId+"?export&type=standalone";
 		      } else {
	            window.location.href="/resources/applications/"+this.CopyMoveAppDialog.currentApp.appId+"?export&type=shared";
 		      }
		}
		
    },
    
    delayedRequestExportApp: function()
    {
		if(zlog.isDebug())console.debug(" in delayedRequestExportApp for export currentApp holds");
		if(zlog.isDebug())console.debug(this.PackageAppDialog.currentApp);

        this.PackageAppDialog.hide();
        if (this.PackageAppDialog.currentApp.pAction == "export") {
		      if ( this.PackageAppDialog.exportStandAloneCheckbox.checked ){
	            window.location.href="/resources/applications/"+this.PackageAppDialog.currentApp.appId+"?export&type=standalone";
 		      } else {
	            window.location.href="/resources/applications/"+this.PackageAppDialog.currentApp.appId+"?export&type=shared";
 		      }
		}
		
    },


    finishMoveCopy: function()
    {
		        this.refresh();
                if (this.newAppId) {
				   var appListRowWidget = dijit.byId("app-list-row-ui-" + this.newAppId);
			       if ( appListRowWidget !== undefined && appListRowWidget !== null  ){
			            setTimeout(dojo.hitch(this, function() {
		                      appListRowWidget.setFocusToLink();
		                }), 1200);
				   }
				   this.newAppId = null;
				}
				dojo.disconnect(this.dlgConnection);
    },

    
    doAppMove: function()
    {
		var callback = function (success, data) {
			if (success && (data)) {
				this._ideWidget.hideProgressDlg();
		        this.newAppId = data.id;
			    this.dlgConnection = dojo.connect(this._statusDialog, 'hideDialog', this, 'finishMoveCopy');
                this._statusDialog.showDialog('Move/Rename Successful', '', this.getMoveCopyMsg(true, false));				
			}
			if (!success) {
				this._ideWidget.hideProgressDlg();
				if (this._statusDialog) {
				   //this._statusDialog.showDialog('Error', '', eval('(' + ioArgs.xhr.responseText + ')').errorMessage);
				   //this._statusDialog.showDialog('Error', '', "Move application failed, see the logs in the Console tab for more information.");
				   var msg="";
				   if (typeof data == "string" && data.length > 0)
				      msg=data;
				   else
				   if (typeof data == "object" && typeof data.errorMessage == "string")
				      msg=data.errorMessage;
				   else
				      msg = "Move application failed, see the logs in the Console tab for more information.";
				   this._statusDialog.showDialog('Error', '', msg);
				   
				}
			}
		};

        var currentPath= this.CopyMoveAppDialog.currentApp.appPath;
        var moveToPath = this.CopyMoveAppDialog.filePathCombo.getValue();
        if (moveToPath.length==0) 
          {
            alert("Please Specify Target Path");
            return;
          }
          
        
        //this._ideWidget.showProgressDlg("Moving Application "+this.CopyMoveAppDialog.currentApp.appName+" from path "+this.CopyMoveAppDialog.currentApp.appPath+ " To: "+moveToPath);
        this._ideWidget.showProgressDlg(this.getMoveCopyMsg(true, true));

		var app = {
			description: this.CopyMoveAppDialog.getDescription(),
			modulegroup: this.CopyMoveAppDialog.getModuleGroup(),
			name: this.CopyMoveAppDialog.appName.getValue(),
			path: moveToPath
		}
        // here is the call to Tim(s) code
		this.updateApplication(this.CopyMoveAppDialog.currentApp.appId, app, dojo.hitch(this,callback));
		
    },

    getMoveCopyMsg: function(bMove, bBefore)
    {
        var moveMsg = 'Application "'+this.CopyMoveAppDialog.currentApp.appName+'"';
        var currentPath= this.CopyMoveAppDialog.currentApp.appPath;
        var moveToPath = this.CopyMoveAppDialog.filePathCombo.getValue();
        var nameChange = this.CopyMoveAppDialog.appName.getValue() !== this.CopyMoveAppDialog.currentApp.appName;
        var pathChange = moveToPath !== currentPath;
		var modgroupChange = this.CopyMoveAppDialog.getModuleGroup() !== this.CopyMoveAppDialog.currentApp.appModuleGroup;
        var renameStr = "renamed";
		if (!bMove) {
			renameStr = "copied";
		}

		if (nameChange) {
		    if (bBefore) {
			    moveMsg = moveMsg + ' will be '+renameStr+' to "'+this.CopyMoveAppDialog.appName.getValue()+'"';
			} else {
			    moveMsg = moveMsg + ' has been '+renameStr+' to "'+this.CopyMoveAppDialog.appName.getValue()+'"';
			}
		}			
	    if (pathChange) {
		    if (bBefore) {
				if (nameChange) {
		            moveMsg = moveMsg + ' and <br> ';	
				}
		        if (bMove) {
		            moveMsg = moveMsg + 'will be moved from "'+currentPath +'" to  "'+moveToPath+'"';
			    } else {
		            moveMsg = moveMsg + 'will be placed in "'+moveToPath+'"';
				
				}	
			} else {
				if (nameChange) {
		            moveMsg = moveMsg + " and <br> ";	
				}
		        if (bMove) {
	                moveMsg = moveMsg + 'has been moved from "'+currentPath +'" to  "'+moveToPath+'"';	
			    } else {
	                moveMsg = moveMsg + 'has been placed in "'+moveToPath+'"';
				}	
			}		
		}	
	    if (modgroupChange) {
		    if (bBefore) {
				if (nameChange || pathChange) {
		            moveMsg = moveMsg + ' and <br> ';	
				}
		        moveMsg = moveMsg + 'will be switched from modulegroup "'+this.CopyMoveAppDialog.currentApp.appModuleGroup+'" to "'+this.CopyMoveAppDialog.getModuleGroup()+'"';	
			} else {
				if (nameChange) {
		            moveMsg = moveMsg + ' and <br> ';	
				}
		        moveMsg = moveMsg + 'has been switched from modulegroup "'+this.CopyMoveAppDialog.currentApp.appModuleGroup+'" to "'+this.CopyMoveAppDialog.getModuleGroup()+'"';	
			}		
		}
		return moveMsg;

	},


    // tjwolf
    updateApplication: function(appid, data, callback)
    {
 		var bindArgs = {
		    url: 'resources/applications/'+appid,
		   	contentType: "text/json-comment-filtered",
		    load: dojo.hitch(this, function(resp, ioargs) {
		    			var response=null;
						var status = ioargs.xhr.status;
						if (resp) {
							response = dojo.fromJson(resp);
						}	
						callback(true, response);
						return resp;
			        }),
			        error: dojo.hitch(this, function(resp, ioargs) {
						console.log("A problem occurred while trying to update application");
						var response=null;
						var status = ioargs.xhr.status;
						// ----- exception data ------
						// if (resp)
						//   response = dojo.fromJson(resp);
						if ((ioargs.xhr.responseText) && ioargs.xhr.responseText.length>0) {
							response = dojo.fromJson(ioargs.xhr.responseText);
						}	
						callback(false, response);
						return resp;
					}),
			        putData : dojo.toJson(data),
			        handleAs: "text"        
			  };
			
		dojo.rawXhrPut(bindArgs);
		
        // test success or failure
        //setTimeout(dojo.hitch(this, function() {
        //        callback(true, data);
        //    }), 2000);
    },

    
    doAppCopy: function()
    {
		var copycallback = function (success, data) {
			if (success && (data)) {
				var msg="";	   
				if (!data.app.isRunnable) {
					var notRunnableDlg = dijit.byId('app-mgr-notrunnable-ui-id');
                    notRunnableDlg._handleNotRunnableDetailsInfo(data);
/*
					if (data.notRunnableDetail && (data.notRunnableDetail.length>0)) {
					    for (var j=0; j<data.notRunnableDetail.length; j++) {
				    	  msg += data.notRunnableDetail[j]+"<br>";
				   	    }				      
				    }
				    if (this._statusDialog) {
					   this._statusDialog.showDialog('Warning', 'The application was added, but it is not runnable.', msg);
				    }
*/				    
				}
				
		        // this.setFocusToNewApp(data.id);
		        // this.refresh();
			
				this._ideWidget.hideProgressDlg();
		        this.newAppId = data.id;
			    this.dlgConnection = dojo.connect(this._statusDialog, 'hideDialog', this, 'finishMoveCopy');
			    if (msg.length==0)
			       msg=this.getMoveCopyMsg(false, false);
                this._statusDialog.showDialog('Copy Successful', '', msg);
			}
			if (!success) {
				this._ideWidget.hideProgressDlg();
				if (this._statusDialog) {
				   var msg="";
				   if (typeof data == "string" && data.length > 0)
				      msg=data;
				   else
				   if (typeof data == "object" && typeof data.errorMessage == "string")
				      msg=data.errorMessage;
				   else
				      msg = "Copy application failed, see the logs in the Console tab for more information.";
				   this._statusDialog.showDialog('Error', '', msg);
				}
			}
		};

        var currentPath= this.CopyMoveAppDialog.currentApp.appPath;
        var moveToPath = this.CopyMoveAppDialog.filePathCombo.getValue();
        if (moveToPath.length==0) 
          {
            alert("Please Specify Target Path");
            return;
          }
          
        
        //this._ideWidget.showProgressDlg("Moving Application "+this.CopyMoveAppDialog.currentApp.appName+" from path "+this.CopyMoveAppDialog.currentApp.appPath+ " To: "+moveToPath);
        this._ideWidget.showProgressDlg(this.getMoveCopyMsg(false, true));

		var app = {
			id: this.CopyMoveAppDialog.currentApp.appId,
			description: this.CopyMoveAppDialog.getDescription(),
			modulegroup: this.CopyMoveAppDialog.getModuleGroup(),
			name: this.CopyMoveAppDialog.appName.getValue(),
			path: moveToPath
		}
        // here is the call to Tim(s) code
		this.copyApplication(app, dojo.hitch(this,copycallback));
		
    },

    copyApplication: function(data, callback)
    {
 		var bindArgs = {
		    url: 'resources/applications',
		   	contentType: "text/json-comment-filtered",
		   	sync: false,   
		    load: dojo.hitch(this, function(resp, ioargs) {
		    			var response=null;
						var status = ioargs.xhr.status;
						if (resp) {
							response = dojo.fromJson(resp);
						}	
						callback(true, response);
						return resp;
			        }),
			        error: dojo.hitch(this, function(resp, ioargs) {
						console.log("A problem occurred while trying to copy application");
						var response=null;
						var status = ioargs.xhr.status;
						if ((ioargs.xhr.responseText) && ioargs.xhr.responseText.length>0) {
							response = dojo.fromJson(ioargs.xhr.responseText);
						}	
						callback(false, response);
						return resp;
					}),
			        postData : dojo.toJson(data),
			        handleAs: "text"        
			  };
			
		dojo.rawXhrPost(bindArgs);
    },
    
    setIdeWidget: function(pWidget)
    {
        this._ideWidget = pWidget;
    },
    
    getParentByType: function (node, type)
    {
        type = type.toLowerCase();
        var result = node;
        while ((result) && (result.nodeName.toLowerCase() != type))
        {
            if (result == this.domNode)
            {
                return null;
            }
            result = result.parentNode;
        }
        return result;
    },

	showHelp : function () {
       window.open (this.product_url + "/docs/zero.gettingstarted.doc/","Zero Admin Help"); // IS THIS A VALID URL??????
    },
	
	showSamples : function () {
       window.open (this.product_url + "/docs/zero.devguide.doc/#samples","Samples");
    },	

	// show Application List
	showNewList : function (pApplications) {
	   if(zlog.isDebug())console.debug("AppMgrUi.showNewList: ENTRY ");

	   var elem = dojo.byId("appListRowContent");
	   elem.innerHTML = "";
       var resultList = [];

/* later hook up sorting
	   //var resultList = this._list.getData();
	   //var sorted = this._list.getSorted();
	   if ((this.sortHeader) && this.sortHeader.listSortHeaderTopNode) {
	     try {
	      elem.removeChild(this.sortHeader.domNode);
	     } catch(e) {
	      if(zlog.isDebug())console.debug("AppMgrUi.showNewList tried to removeChild - but not there ok ");
	     }
	   
	   }
       this.setFilterHeaders();
*/	   
//add in the extra sample data...temp temp temp
       for (var i=0  ;  i < pApplications.length  ;  i++)
       {			
			//resultList.push(pApplications[i]);
			//resultList.push(pApplications.this.datarow);
			resultList[i]= pApplications[i];
			
			//temp sample data
			//resultList[i].module_group = this.datarow.module_group;
			resultList[i].tags = this.datarow.tags;
			//resultList[i].last_accessed = this.datarow.last_accessed;
			var tempTime = new Date();
			if(zlog.isDebug())if(zlog.isDebug())console.debug("AppMgrUi.showNewList: tempTime = ");
			if(zlog.isDebug())console.debug(tempTime);
			//resultList[i].last_accessed = new Date().toLocaleString();
            resultList[i].last_accessed = new Date().toUTCString();
			//resultList[i].last_accessed = new Date().getTime();
        }
        this.sortDataControl( elem, resultList );

        this.setAppAreaSize();	

	    if(zlog.isDebug())console.debug("AppMgrUi.showNewList: EXIT ");   
	},

	setAppAreaSize : function (expandAllFlow ) {

/*djb [03/26/2008] removed this code due to removal of the dojo.container container
		if(zlog.isLog())console.log("In appMgrUI setAppAreaSize need to resize? myApps = &*************expandAllFlow ="+expandAllFlow);
		if(zlog.isLog())console.log(this.myApps);
		var y = dojo.byId("appListRowContent");
		if(zlog.isLog())console.log("before resize y.clientHeight = "+y.clientHeight);
		if(zlog.isLog())console.log("before resize y.clientWidth = "+y.clientWidth);
		if(zlog.isLog())console.log("before resize myApps.domNode.clientHeight = "+this.myApps.domNode.clientHeight);
		if(zlog.isLog())console.log("before resize myApps.domNode.clientWidth = "+this.myApps.domNode.clientWidth);

//djb [03/26/2008] removed appListHeader
//		var hdry = dojo.byId("appListHeader");
//		if(zlog.isLog())console.log("before resize hdry.clientHeight = "+hdry.clientHeight);


        var yszH = this.myApps.domNode.clientHeight;
	    if (y.clientHeight > 0) {
			//yszH =  y.clientHeight+114;
			//yszH =  y.clientHeight+88;
			yszH =  y.clientHeight+hdry.clientHeight+20;
	    }			

        var yszW = this.myApps.domNode.clientWidth;
	    if (y.clientWidth > 0 && expandAllFlow) {
			yszW =  y.clientWidth+21;
			if(zlog.isLog())console.log("before resize in expandAllFlow setting yszW = "+yszW);
	    } else if (yszW === 0 && y.clientWidth === 0 ) {
			yszW = this.savedYszW;
		}
		this.savedYszW = yszW; 			


			var sz3 = {h:yszH,
			          w:yszW
			};
	
			if(zlog.isLog())console.log("before resize yszH sz3.h = "+yszH);
			if(zlog.isLog())console.log("before resize yszH sz3.w = "+yszW);

			if(zlog.isLog())console.log("before resize myApps.domNode.clientHeight = "+this.myApps.domNode.clientHeight);
			if(zlog.isLog())console.log("before resize myApps.domNode.clientWidth = "+this.myApps.domNode.clientWidth);
	
	        this.myApps.resize(sz3);
//			this.myApps.refresh();

			if(zlog.isLog())console.log("after resize in myApps.domNode.clientHeight = "+this.myApps.domNode.clientHeight);
			if(zlog.isLog())console.log("after resize in myApps.domNode.clientWidth = "+this.myApps.domNode.clientWidth);
*/
	},
	resize: function(args) {
		var newHeight = document.body.clientHeight;
		if (window.innerHeight) {  // set on firefox 
			newHeight = window.innerHeight;   
		} else {                   // tweak for IE
			newHeight = newHeight + 22; 
		}		
		if (args && args.h) {
			newHeight = h;
		}
		var innerHeight = newHeight;
		try {
			var lowerbox = dojo.marginBox(dojo.byId("lotusFooter")); //M
			var upperbox = dojo.marginBox(dojo.byId("banner")); //C
			var middlebox = dojo.marginBox(dojo.byId("lotusTitleBar"));//C
		   if (window.innerHeight) {
			  newHeight = newHeight - lowerbox.h; // good for FF.
			  innerHeight = newHeight - upperbox.h - middlebox.h;
 			} else {                 // tweak for IE
			  newHeight = newHeight - lowerbox.h - upperbox.h;
			  innerHeight = newHeight - upperbox.h - middlebox.h;
			}
			//innerHeight has a min height of 400
			if (innerHeight < 400)	{
				innerHeight = 400;
				newHeight = 400 + upperbox.h + middlebox.h;
			}
		} catch(e) {
			if(zlog.isDebug())console.debug("AppMgrUI: resize, Error finding size of lotus elements.");
		}
		this.domNode.style.height = newHeight+"px";
		
		var contentH = innerHeight-36; //36 is top(16) + bottom(20) margin
		if (window.innerHeight) {
            dojo.byId("lotusMain").style.height = innerHeight+"px"; 
			dojo.byId("lotusContent").style.height = contentH+"px";
        } else {
			//innerHeight = innerHeight + 30;  // tweak for IE
			//contentH = innerHeight-30;
			contentH = innerHeight; 
            dojo.byId("lotusMain").style.height = contentH+"px";
			//contentH = innerHeight-36;
			contentH = innerHeight-6; 
			dojo.byId("lotusContent").style.height = contentH+"px";
			
		}  				
      
		if(zlog.isDebug())console.debug("AppMgrUi: setting domNode.h = "+newHeight+"/"+innerHeight);
	},

/*
 * Called by showNewList to setup the Sorted Data.
*/
	//List - sort data items 
	sortDataControl : function ( elem, data ) {
	   if(zlog.isDebug())console.debug("AppMgrUi.sortDataControl: ENTRY ");
/*	   
	   var sorted = this._listModel.getSorted();
	   var pginfo = this._listModel.getPageInfo();
	
	   if (!(this.sortHeader)) {
	//           this.sortHeader = dojo.widget.createWidget("zero.catalog:ListSortHeader",
	         this.sortHeader = new zero.ide.widget.environment.ListSortHeader( 
	                       {
	                          "sortStr":sorted,
	                          "sortDir":sortdir,
	                          "page_info":pginfo,
							  "showDescription":this.showDescription,
	                          "messages":messages
	                       }, 
	                       dojo.byId("sortHeaderNode") ); 
			  this.sortHeadConnections = [];
		      this.sortHeadConnections[0] = dojo.connect(this.sortHeader, 'switchSort', this, 'handleSortList');
			  this.sortHeadConnections[1] = dojo.connect(this.sortHeader, 'reverseSort', this, 'handleReverseSort');
			  this.sortHeadConnections[2] = dojo.connect(this.sortHeader, 'includeDescription', this, 'handleIncludeDescription');
			  this.sortHeadConnections[3] = dojo.connect(this.sortHeader, 'hideDescription', this, 'handleHideDescription');
			  this.sortHeadConnections[4] = dojo.connect(this.sortHeader, 'showFilterList', this, 'handleHeaderFilterList');
			  this.sortHeadConnections[5] = dojo.connect(this.sortHeader, 'filterList', this, 'handleFilterList');
			  this.sortHeadConnections[6] = dojo.connect(this.sortHeader, 'clearFilterForKey', this, 'handleClearHeaderFilter');
			  this.sortHeadConnections[7] = dojo.connect(this.sortHeader, 'switchPage', this, 'handleSwitchPage');
	
	          if(zlog.isDebug())console.debug("ListViewController.sortDataControl: setup 4 event.connects for sortheader ");
	
	
	                       
	   }	   
	   elem.appendChild(this.sortHeader.domNode);  
	
*/	
	   //Clear previous listrows if any exist
	   if(zlog.isDebug())console.debug("AppMgrUi.sortDataControl: calling destroy for any previous listrow widgets this.myListRowWidgets.length = "+this.myListRowWidgets.length);
	   this.clearListRows();
       for (var i=0  ;  i < data.length  ;  i++)
       {			
            this.addDataRow( elem, data[i] ); // now addDataRow is the same for all sorts

       }
	   	   
 	   var val = this.appFilter.value;
	   if (val && val.length > 0 && val !== this.messages.app_FilterDots) {
		  if(zlog.isDebug())console.debug("in AppMgrUi-doappFilterKey filter for "+val);
	      this.handleDoFilter(val);
	   }

       if (this.newAppId) {
		   var appListRowWidget = dijit.byId("app-list-row-ui-" + this.newAppId);
	       if ( appListRowWidget !== undefined && appListRowWidget !== null  ){
			   
	           setTimeout(dojo.hitch(this, function() {
                appListRowWidget.setFocusToLink();
            }), 800);

		   }
		   this.newAppId = null;
	   }

	  
	   if(zlog.isDebug())console.debug("AppMgrUi.sortDataControl: EXIT ");   
	   return elem; // return element
	},

	       
	/*
	 * Called by the addXxxDataRow functions to setup Data row.
	 */
	setupItemRow : function (elem, datarow) {
	   if(zlog.isDebug())console.debug("AppMgrUi.setupItemRow: ENTRY "+datarow.name);
	 
       var itemrow = new zero.ide.widget.appmgr.AppListRow( 
                       {  "id": "app-list-row-ui-"+datarow.id,
                          "datarow":datarow,
                          "name":datarow.name,
						        "admin": this.admin,
                          //"messages":"",
                          "showDescription" : this.showDescription }, 
                       dojo.byId("appRowNode") ); 
       elem.appendChild(itemrow.domNode);  
       this.myListRowWidgets.push(itemrow);
	   itemrow.startup();  
	   
	   if(zlog.isDebug())console.debug("AppMgrUi.setupItemRow: EXIT itemrow.id = "+itemrow.id);
	
	},

	/*
	 * sortDataControl to call this method to clear out/destroy widgets on a sort
	 */
	clearListRows : function (  ) {
	   if(zlog.isDebug())console.debug("AppMgrUi.clearListRows: ENTRY ");
	   if (this.myListRowWidgets.length > 0) {
	     for (var j=0; j<this.myListRowWidgets.length; j++) {
	      this.myListRowWidgets[j].destroy();   
	      this.myListRowWidgets[j] = null;   
	     }
	     this.myListRowWidgets = [];
	   }
	   if(zlog.isDebug())console.debug("AppMgrUi.clearListRows: EXIT ");   
	},
	
	/*
	 * Called by sortDataControl to add one Data row by Name
	 */
	addDataRow : function ( elem, datarow ) {
	   if(zlog.isDebug())console.debug("AppMgrUi.addDataRow: ENTRY ");
	   var gh = document.createElement("div");
	   elem.appendChild(gh);
	   
	   this.setupItemRow(elem, datarow);//create "div" element and set class
	   if(zlog.isDebug())console.debug("AppMgrUi.addDataRow: EXIT ");   
	   return elem;  
	},
	
		
    doAppFilterKey: function(evt) {
       if (!evt.altKey && !evt.ctrlKey) {
		  var val = this.appFilter.value;
	      var filterStr = val;
		  if(zlog.isDebug())console.debug("in AppMgrUi-doappFilterKey filter for "+val);
	      this.handleDoFilter(val);
	   }
    },

		
    handleDoFilter: function(val) {
	  if(zlog.isDebug())console.debug("in AppMgrUi-handleDoFilter called for "+val);
      if (this.myListRowWidgets.length > 0) {
	     for (var j=0; j<this.myListRowWidgets.length; j++) {
	      if (val == this.appFilter.value) {
		     this.myListRowWidgets[j]._handleFilter(val);
		  } else {
		    if(zlog.isDebug())console.debug("AppMgrUi.handleDoFilter breaking because of new val ="+this.appFilter.value);
		  	break;
		  }   
	     }
	  }
    },

/*
 * 
 * appListHeaderRefresh Functions
 * 
 */
		appListHeaderRefreshClick: function(evt) {
		   if(zlog.isDebug())console.debug("appListHeader appListHeaderRefreshClick : ENTER key is " + this.key);
           this.refresh(); 
        },


		appListHeaderRefreshOnKey: function(evt ) {
           if(zlog.isDebug())console.debug("appListHeaderRefreshOnKey name : " + this.name + " evt.charCode ="+evt.charCode);
           if (evt.charCode == dojo.keys.SPACE || evt.keyCode == dojo.keys.ENTER) {
             this.refresh(); 
           }
        },


/*
 * 
 * appListHeaderSort Functions
 * 
 */
		appListHeaderSortClick: function(evt) {
		   if(zlog.isDebug())console.debug("appListHeader appListHeaderSortClick : evt = ");
		   if(zlog.isDebug())console.debug(evt);
           //this.refresh();
		   this.appListSort(evt); 
        },


		appListHeaderSortOnKey: function(evt ) {
           if(zlog.isDebug())console.debug("appListHeaderSortClick name : " + this.name + " evt.charCode ="+evt.charCode);
           if (evt.charCode == dojo.keys.SPACE || evt.keyCode == dojo.keys.ENTER) {
		      this.appListSort(evt); 
           }
        },

		appListSort: function(evt ) {
           if(zlog.isDebug())console.debug("appListSort called this[evt.target.id] = " + evt.target.id);
		   //sortdir = "ASC";
		   //sortdir = "DESC";
           this.sortData = this._controller.currentApps.slice(); //clone app list
           if(zlog.isDebug())console.debug("appListSort data before sort = ");
		   if(zlog.isDebug())console.debug(this.sortData);
           if (evt.target.id == "appListHeaderNameNode") {  //sort by name
               if (this.sortKey == this.SORT_NAME) {
                  this.reverseSort(this.appListHeaderNameNode, this.SORT_NAME);
	           } else {
	              this.removeOldSort();
                  this.setupNewSort(this.appListHeaderNameNode, this.SORT_NAME);				  
	           }
		       this.sortKey = this.SORT_NAME;
		   } else if (evt.target.id == "appListHeaderPathNode") {  //sort by path
               if (this.sortKey == this.SORT_PATH) {
                  this.reverseSort(this.appListHeaderPathNode, this.SORT_PATH);
	           } else {
	              this.removeOldSort();
                  this.setupNewSort(this.appListHeaderPathNode, this.SORT_PATH);				  
	           }
		       this.sortKey = this.SORT_PATH;
		   }  else if (evt.target.id == "appListHeaderLastAccessedNode") {  //sort by lastAccessed
               if (this.sortKey == this.SORT_LASTACCESSED) {
                  this.reverseSort(this.appListHeaderLastAccessedNode, this.SORT_LASTACCESSED);
	           } else {
	              this.removeOldSort();
                  this.setupNewSort(this.appListHeaderLastAccessedNode, this.SORT_LASTACCESSED);				  
	           }
		       this.sortKey = this.SORT_LASTACCESSED;
		   }  else if (evt.target.id == "appListHeaderStatusNode") {  //sort by status
               if (this.sortKey == this.SORT_STATUS) {
                  this.reverseSort(this.appListHeaderStatusNode, this.SORT_STATUS);
	           } else {
	              this.removeOldSort();
                  this.setupNewSort(this.appListHeaderStatusNode, this.SORT_STATUS);				  
	           }
		       this.sortKey = this.SORT_STATUS;
		   }
           this.doSort();
		    
		   this.showNewList(this.sortData);
		   
        },

		doSort : function ()
		{
	       if(zlog.isDebug())console.debug("AppMgrUi doSort this.sortKey = "+this.sortKey + " sortdir = "+sortdir);			
		   if (this.sortKey == "lastAccessed") {  //sort by lastAccessed
	          this.sortData.sort(this.sortLastAccessedFunc);
		   } else if (this.sortKey == "name") {  //sort by name
	          this.sortData.sort(this.sortNameFunc);
		   }  else if (this.sortKey == "path") {  //sort by path
	          this.sortData.sort(this.sortPathFunc);
		   }  else if (this.sortKey == "status") {  //sort by status
	          this.sortData.sort(this.sortStatusFunc);
		   }
	       if(zlog.isDebug())console.debug("appListSort this.sortData after sort by this.sortKey = "+this.sortKey);
	       if(zlog.isDebug())console.debug(this.sortData);
        },

		switchSortDir : function ()
		{
		    if(zlog.isDebug())console.debug("ListModel.switchSortDir ENTRY/EXIT ");
		    if (sortdir == "ASC" ) {
		       sortdir = "DESC";
		    } else {
		       sortdir = "ASC";
		    }
		    
		    this.doSort();
		},                                                        


		sortNameFunc : function (a,b)
		{
          if(zlog.isDebug())console.debug("sortNameFunc a.name = "+a.name+"  b.name ="+b.name + " sortdir = "+sortdir);
		  if (sortdir == "ASC") { 	
          if(zlog.isDebug())console.debug("sortNameFunc in ASC a.name = "+a.name+"  b.name ="+b.name);
		    if (a.name.toUpperCase()>b.name.toUpperCase()) {return 1;}
			if (a.name.toUpperCase()<b.name.toUpperCase()) {return -1;}
		  } else {
          if(zlog.isDebug())console.debug("sortNameFunc in DESC a.name = "+a.name+"  b.name ="+b.name);

		    if (a.name.toUpperCase()>b.name.toUpperCase()) {return -1;}
			if (a.name.toUpperCase()<b.name.toUpperCase()) {return 1;}
		  }
		  return 0;
		},                                                        

		sortPathFunc : function (a,b)
		{
          if(zlog.isDebug())console.debug("sortNameFunc a.path = "+a.path+"  b.path ="+b.path + " sortdir = "+sortdir);
		  if (sortdir == "ASC") { 	
          if(zlog.isDebug())console.debug("sortPathFunc in ASC a.path = "+a.path+"  b.path ="+b.path);
		    if (a.path.toUpperCase()>b.path.toUpperCase()) {return 1;}
			if (a.path.toUpperCase()<b.path.toUpperCase()) {return -1;}
		  } else {
          if(zlog.isDebug())console.debug("sortPathFunc in DESC a.path = "+a.path+"  b.path ="+b.path);
		    if (a.path.toUpperCase()>b.path.toUpperCase()) {return -1;}
			if (a.path.toUpperCase()<b.path.toUpperCase()) {return 1;}
		  }
		  return 0;
		},                                                        


		sortLastAccessedFunc : function (a,b)
		{
          if(zlog.isDebug())console.debug("sortLastAccessedFunc a.id = "+a.id+"  b.id ="+b.id + " sortdir = "+sortdir);
		  if (sortdir == "ASC") { 	
          if(zlog.isDebug())console.debug("sortLastAccessedFunc in ASC a.id = "+a.id+"  b.id ="+b.id);
		    if (a.id>b.id) {return 1;}
			if (a.id<b.id) {return -1;}
		  } else {
          if(zlog.isDebug())console.debug("sortLastAccessedFunc in DESC a.id = "+a.id+"  b.id ="+b.id);
		    if (a.id>b.id) {return -1;}
			if (a.id<b.id) {return 1;}
		  }
		  return 0;
		},                                                        

		sortStatusFunc : function (a,b)
		{
          if(zlog.isDebug())console.debug("sortStatusFunc a.isRunning = "+a.isRunning+"  b.isRunning ="+b.isRunning + " sortdir = "+sortdir);
		  if (sortdir == "ASC") { 	
          if(zlog.isDebug())console.debug("sortStatusFunc in ASC a.isRunning = "+a.isRunning+"  b.isRunning ="+b.isRunning);
		    if (a.isRunning && !b.isRunning) {return 1;}
			if (!a.isRunning && b.isRunning) {return -1;}
		  } else {
          if(zlog.isDebug())console.debug("sortStatusFunc in DESC a.isRunning = "+a.isRunning+"  b.isRunning ="+b.isRunning);
		    if (a.isRunning && !b.isRunning) {return -1;}
			if (!a.isRunning && b.isRunning) {return 1;}
		  }
		  return 0;
		},                                                        


      
      removeHoverClasses: function() {
        if(zlog.isDebug())console.debug("listSortHeader removeHoverClasses ENTER ");

        // try to clear hover focus to fix problem on IE
//          dojo.removeClass(this.appListHeaderNameNode, "explore-sort-hover");
//          dojo.removeClass(this.appListHeaderPathNode, "explore-sort-hover");
//          dojo.removeClass(this.appListHeaderLastAccessedNode, "explore-sort-hover");
//          dojo.removeClass(this.appListHeaderStatusNode, "explore-sort-hover");
      },

      setupNewSort: function(node, sort) {
        if(zlog.isDebug())console.debug("AppMgrUi setupNewSort : ENTER this.sortKey ="+this.sortKey+ "sortdir = "+sortdir);
      
		// these are defined in general.js
		clearSort(node);
		reverseSort(node);

//djb [03/26/2008] replaced by clearSort/reverseSort above		
//        if (sortdir === this.SORT_DESC) {
//              dojo.removeClass(node, "explore-sort-a");
//              dojo.addClass(node, "explore-sort-desc-a");
//        } else {
//              dojo.removeClass(node, "explore-sort-a");
//              dojo.addClass(node, "explore-sort-asc-a");
//        }
                 
      },


      reverseSort: function(node, sort) {
        if(zlog.isDebug())console.debug("ListSortHeader ListSortHeader reverseSort : ENTER this.sortKey ="+this.sortKey+ "sortdir = "+sortdir);
      
        if (sortdir === this.SORT_DESC) {
           sortdir = this.SORT_ASC;
        } else {
           sortdir = this.SORT_DESC;
        }

		// these are defined in general.js
		clearSort(node);
		reverseSort(node);

//djb [03/26/2008] replaced by clearSort/reverseSort above		
//        if (sortdir === this.SORT_DESC) {
//              dojo.removeClass(node, "explore-sort-asc-a");
//             dojo.addClass(node, "explore-sort-desc-a");
//        } else {
//              dojo.removeClass(node, "explore-sort-desc-a");
//              dojo.addClass(node, "explore-sort-asc-a");
//        }

                 
      },

	  
      removeOldSort: function() {
        if(zlog.isDebug())console.debug("listSortHeader removeOldSort ENTER this.sortKey = "+this.sortKey+ " sortdir = "+sortdir);

        // try to clear hover focus to fix problem on IE
        this.removeHoverClasses();

/*djb [03/26/2008] - replaced by lotus functions in setupSort and reverseSort
        if (this.sortKey === this.SORT_NAME) {
           if (sortdir === this.SORT_DESC) {
              dojo.removeClass(this.appListHeaderNameNode, "explore-sort-desc-a");
              dojo.addClass(this.appListHeaderNameNode, "explore-sort-a");
           } else {
              dojo.removeClass(this.appListHeaderNameNode, "explore-sort-asc-a");
              dojo.addClass(this.appListHeaderNameNode, "explore-sort-a");
           }
        } else if (this.sortKey === this.SORT_PATH) {
           if (sortdir === this.SORT_DESC) {
              dojo.removeClass(this.appListHeaderPathNode, "explore-sort-desc-a");
              dojo.addClass(this.appListHeaderPathNode, "explore-sort-a");
           } else {
              dojo.removeClass(this.appListHeaderPathNode, "explore-sort-asc-a");
              dojo.addClass(this.appListHeaderPathNode, "explore-sort-a");
           }
        } else if (this.sortKey === this.SORT_LASTACCESSED) {
           if (sortdir === this.SORT_DESC) {
              dojo.removeClass(this.appListHeaderLastAccessedNode, "explore-sort-desc-a");
              dojo.addClass(this.appListHeaderLastAccessedNode, "explore-sort-a");
           } else {
              dojo.removeClass(this.appListHeaderLastAccessedNode, "explore-sort-asc-a");
              dojo.addClass(this.appListHeaderLastAccessedNode, "explore-sort-a");
           }
        } else if (this.sortKey === this.SORT_STATUS) {
           if (sortdir === this.SORT_DESC) {
              dojo.removeClass(this.appListHeaderStatusNode, "explore-sort-desc-a");
              dojo.addClass(this.appListHeaderStatusNode, "explore-sort-a");
           } else {
              dojo.removeClass(this.appListHeaderStatusNode, "explore-sort-asc-a");
              dojo.addClass(this.appListHeaderStatusNode, "explore-sort-a");
           }
        }
*/
        if(zlog.isDebug())console.debug("listSortHeader switchSort EXIT this.sortKey = "+this.sortKey+ " sortdir = "+sortdir);
                 
      },


	
/*
 * 
 * appListHeaderShowDescription Functions
 * 
 */
		appListButtonClick: function(evt) {
		   if(zlog.isDebug())console.debug("appListButtonClick : ENTER key is " + this.key);
           if (this.showDescription) {
               this.hideDescription();
           } else {
               this.includeDescription();
           }
           //dojo.stopEvent(evt);

        },

		appDetailsButtonClick: function(evt) {
		   if(zlog.isDebug())console.debug("appDetailsButtonClick : ENTER key is " + this.key);
           if (this.showDescription) {
               this.hideDescription();
           } else {
               this.includeDescription();
           }
           //dojo.stopEvent(evt);

        },

		appListHeaderShowDescriptionClick: function(evt) {
		   if(zlog.isDebug())console.debug("appListHeader appListHeaderShowDescriptionClick : ENTER key is " + this.key);
           if (this.showDescription) {
               this.hideDescription();
           } else {
               this.includeDescription();
           }
           //dojo.stopEvent(evt);

        },


		appListHeaderShowDescriptionOnKey: function(evt ) {
           if(zlog.isDebug())console.debug("appListHeaderShowDescriptionOnKey name : " + this.name + " evt.charCode ="+evt.charCode);
           if (evt.charCode == dojo.keys.SPACE || evt.keyCode == dojo.keys.ENTER) {
             if (this.showDescription) {
                 this.hideDescription();
             } else {
                this.includeDescription();
             }
             //dojo.stopEvent(evt);
           }
        },


		
    handleShowDescription: function(show) {
	  if(zlog.isDebug())console.debug("in AppMgrUi-handleShowDescription called with "+show);
	   if (this.myListRowWidgets.length > 0) {
	     for (var j=0; j<this.myListRowWidgets.length; j++) {
	      this.myListRowWidgets[j]._showDescription(show);   
	     }
	   }
	  
    },
		
    _handleListRowAction: function(msg) {
	  // msg holds - pAction, appId, appName appPath	
	  if(zlog.isDebug())console.debug("in AppMgrUi-_handleListRowActionShowDescription called with  msg.pAction ="+msg.pAction);
	  if(zlog.isDebug())console.debug("in AppMgrUi-_handleListRowActionShowDescription called with  msg.pApp ="+msg.appName);
	  if (msg.pAction == "move") {
	  	              this.moveApp(msg);
	                  //alert("Move function is coming soon....");
	  } else if (msg.pAction == "copy") {
	                  this.copyApp(msg);
      } else if (msg.pAction == "export") {
	                  this.exportApp(msg);
	                  //alert("Export function is coming soon....");
      }      					  
    },


      includeDescription: function(node, sort) {
        if(zlog.isDebug())console.debug("appListHeader includeDescription : ENTER this.showDescription ="+this.showDescription);

        this.showDescription = true;
		this.handleShowDescription(true);   
		   
        dojo.removeClass(this.appListButton, "lotusListOn");
        dojo.addClass(this.appListButton, "lotusListOff");

        dojo.removeClass(this.appDetailsButton, "lotusDetailsOff");
        dojo.addClass(this.appDetailsButton, "lotusDetailsOn");

        // need to adjust the width here, because it gets skinnier every time I do 
//        this.setAppAreaSize(true);	

        if(zlog.isDebug())console.debug("appListHeader includeDescription : EXIT this.showDescription ="+this.showDescription);
      },


      hideDescription: function(node, sort) {
        if(zlog.isDebug())console.debug("appListHeader hideDescription : ENTER this.showDescription ="+this.showDescription);

        this.showDescription = false;
		this.handleShowDescription(false);

        dojo.removeClass(this.appListButton, "lotusListOff");
        dojo.addClass(this.appListButton, "lotusListOn");

        dojo.removeClass(this.appDetailsButton, "lotusDetailsOn");
        dojo.addClass(this.appDetailsButton, "lotusDetailsOff");


        //this.setAppAreaSize(); skip this call to leave space for individual expands...	

        if(zlog.isDebug())console.debug("appListHeader hideDescription : EXIT this.showDescription ="+this.showDescription);
      },

	
	appListHeaderOver: function(evt ) {
       if(zlog.isDebug())console.debug("AppListRow.appListHeaderOver: enter -> name : " + this.name );
       //dojo.stopEvent(evt);
   
       //if(zlog.isDebug())console.debug("AppListRow.appListHeaderOver over: evt : " + evt );
       //if(zlog.isDebug())console.debug( evt );
       //dojo.addClass(this.appListRowExportNode, "listrow-itemrowHover");
       
       //if(zlog.isDebug())console.debug(" ListRowover: EXIT");
	},

	appListHeaderOut: function(evt ) {
     //  if(zlog.isDebug())console.debug("AppListRow.appListHeaderOut: leaving -> name : " + this.name );
      //dojo.stopEvent(evt);
      //dojo.removeClass(this.appListRowExportNode, "listrow-itemrowHover");

    },

	appListHeaderOnFocus: function(evt ) {
       //if(zlog.isDebug())console.debug("AppListRow.appListHeaderOnFocus name : " + this.name );
       //dojo.stopEvent(evt);
       //dojo.addClass(this.appListRowExportNode, "listrow-itemrowHover");
       dojo.addClass(this[evt.target.id], "listrowlinkHover");
	   
    },

	appListHeaderOnBlur: function(evt ) {
       //if(zlog.isDebug())console.debug("AppListRow.appListHeaderOnBlur name : " + this.name );
       //dojo.stopEvent(evt);
       //dojo.removeClass(this.appListRowExportNode, "listrow-itemrowHover");
       dojo.removeClass(this[evt.target.id], "listrowlinkHover");

    },



    postMixInProperties: function()
    {
        zero.ide.widget.appmgr.AppMgrUi.superclass.postMixInProperties.apply(this, arguments);
    
		//this.lang = 'de-de';
		this.messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "AppMgrUiNls", this.lang);

	
        this._uid = dojox.uuid.generateRandomUuid();        
        if (this.showDescription === "") { this.showDescription = true; }

    },
		
      postCreate: function() {
         if(zlog.isDebug())console.debug("AppMrgUi this.showDescription" + this.showDescription);

        //elc try to do this here NOTE ALL OF THESE NEED TO BE SAVED AND DISCONNECTED						 
        var clc = dijit.byId('mgrCommonLCont');
		dojo.connect(clc, '_linkClicked',
						 this, '_browseLinkClicked');

         if (!this.showDescription) {
            this.showDescription = false;
			
	        dojo.removeClass(this.appListButton, "lotusListOff");
	        dojo.addClass(this.appListButton, "lotusListOn");
	
	        dojo.removeClass(this.appDetailsButton, "lotusDetailsOn");
	        dojo.addClass(this.appDetailsButton, "lotusDetailsOff");
         } else {
	        dojo.removeClass(this.appListButton, "lotusListOn");
	        dojo.addClass(this.appListButton, "lotusListOff");
	
	        dojo.removeClass(this.appDetailsButton, "lotusDetailsOff");
	        dojo.addClass(this.appDetailsButton, "lotusDetailsOn");
         }

	     if (this.admin) {
		   	  dojo.style(this.copyFromRepoLi, "display", "none");
		   	  dojo.style(this.newApplicationLi, "display", "none");
			  
		 }
		 
	     this.inherited("postCreate", arguments);
		 
      },

    
    startup: function()
    {
        zero.ide.widget.appmgr.AppMgrUi.superclass.startup.apply(this, arguments);
		if (this._statusDialog === null) {
          this._statusDialog = dijit.byId('status-dialog');
        }
        if (!this.objectConnections) {
	        this.objectConnections = [];
            this.objectConnections[0] = dojo.subscribe("MgrListRowAction", this, "_handleListRowAction");
		}
		  
    
        // Setup My Applications Table
/*        dojo.connect(this.myAppsTable.domNode, 'onclick', // ELC change ondblclick to onclick
                     this, '_onMyAppsClick');
        dojo.connect(this.myAppsTable, 'onCellFilled',
                     this, '_onMyAppsCellFilled');
        dojo.connect(this.myAppsTable, 'onDataToggle',
                     this, '_onMyAppsDataToggled');
*/                                         
    },
    
    // dojo Attach Points
    myApps: null,
    myAppsDropdownMenu: null,
    myAppsLaunchItem: null,
    myAppsLaunchFormItem: null,
    myAppsTable: null,
    //myAppsUnpublishItem: null,
    removeDialog: null,
	browseApplicationsDialog: null,
	copyFromRepositoryDialog: null,
	importApplicationDialog: null,
	CopyMoveAppDialog: null,
	PackageAppDialog: null,
    statusMessage: null,
	fileSelectionConn: null,
	copyFromRepositoryConn: null,
	// importApplicationConn: null,
	copyAppConn: null,
	exportAppConn: null,
	sortData : [],
	sortKey : "name",
	_statusDialog : null,
	appListDirty : true,

	newAppId: null,
    
    // dojo Event stub
    showEditor: function() {}
}
);

}