/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *  WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
        /* Copyright (c) 2008 by IBM Corporation */

if(!dojo._hasResource["zero.ide.widget.appmgr.NotRunnableDialog"]){
dojo._hasResource["zero.ide.widget.appmgr.NotRunnableDialog"] = true;
dojo.provide("zero.ide.widget.appmgr.NotRunnableDialog");
dojo.requireLocalization("zero.ide.widget.appmgr", "CommonAppDialogNls");


dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.Textarea");
dojo.require("dijit.form.TextBox");
dojo.require('dijit.Tooltip');
dojo.require('dijit._Templated');
dojo.require('dijit._Widget');
dojo.require("dojox.uuid.generateRandomUuid");

dojo.declare("zero.ide.widget.appmgr.NotRunnableDialog",
             [dijit._Widget, dijit._Templated],
{
    widgetsInTemplate: true,
    templatePath: dojo.moduleUrl("zero","ide/widget/appmgr/templates/NotRunnableDialog.html"),
    messages:"",

    getNotRunnableInfo: function(appid)
    {
        if(zlog.isDebug())console.debug("NotRunnableDialog: getRunnableStatus  - ENTRY/EXIT");
		
		this.resourceString = this.baseResourceString +"/"+ appid + "/runnablestatus";

        this.getNotRunnableDetails();
    },

    show: function()
    {			    	
        if(zlog.isDebug())console.debug("NotRunnableDialog: show  - ENTRY/EXIT");

	    // set timeout to allow the browser to render dialog and then set focus
        setTimeout(dojo.hitch(this, function() {
              this.okButton.focus();
               }), 600);
        this.notRunnableDialog.show();
        if(zlog.isDebug())console.debug(this.notRunnableDialog);
    },
    
	hide: function() {
        this.notRunnableDialog.hide();
        this.dialogClosed();
	},
	
	getNotRunnableDetails : function () {

      if(zlog.isDebug())console.debug("NotRunnableDialog.getNotRunnableDetails ENTRY");
      var ide = dijit.byId('app-mgr-ui-id');
      ide.showProgressDlg(this.messages.notRunnableProgressInd);//show progress dialog
	  var bindArgs = {};
	  
      //construct create args
          bindArgs = {
	  	      url: this.resourceString, 
	          load: dojo.hitch(this, this._handleNotRunnableDetailsInfo),    
	          error: dojo.hitch(this, this._handleNotRunnableError),
			  preventCache: true,
			  handleAs: "json"					 
	   	  };
   	  var request = dojo.xhrGet(bindArgs); //get info on this application why its not runnable
      if(zlog.isDebug())console.debug("NotRunnableDialog.getNotRunnableDetails - EXIT" );
	},
	
	_updateClicked: function() {
		this._updateDependencies();
	},

	_updateDependencies: function() {
		    var ide = dijit.byId('app-mgr-ui-id');
			ide.showProgressDlg(this.messages.updating_deps);
			
			var app = {command:'update'}
			
			if(zlog.isDebug())console.debug("in _updateDependencies");
	  		var paramsObj = {  
	        	url: '/resources/applications/'+this.appId,
	        	sync: false,   
				postData: dojo.toJson(app),
	        	// preventCache: true,
		    	load: dojo.hitch(this, this._appUpdated),    
	        	error: dojo.hitch(this, this._appUpdateError),
	        	contentType: "application/json",
				mimetype: "text/json-comment-filtered",
	        	handleAs: 'json'		
			}		
			dojo.rawXhrPost(paramsObj);
	},


	_appUpdated: function (response, ioArgs) 
	{		
        var ide = dijit.byId('app-mgr-ui-id');
	    ide.hideProgressDlg();
		this.hide();
		this.getNotRunnableInfo(this.appId);
		return response;
	},
		
	_appUpdateError: function (response, ioArgs) 
	{
            var ide = dijit.byId('app-mgr-ui-id');
	        ide.hideProgressDlg();

			//var manager = dijit.byId('app-mgr-ui-id');					
			var msg = "";
			var resp = eval('(' + ioArgs.xhr.responseText + ')');
			if (resp.errorMessage && (resp.errorMessage.length>0)) {
			    for (var j=0; j<resp.errorMessage.length; j++) {
		    	  msg += resp.errorMessage[j]+"<br>";
		   	    }				      
		    }
			ide._statusDialog.showDialog('Error', dojo.string.substitute(this.messages.failed_update_deps), msg);
			return response;	
	},			

	
    _handleNotRunnableDetailsInfo:  function (response, args) {
      if(zlog.isDebug())console.debug("NotRunnableDialog._handleRunnableDetailsInfo - ENTER" );
      
	  this.appId = response.app.id;
	  
      var ide = dijit.byId('app-mgr-ui-id');
	  ide.hideProgressDlg();
	  if (response.app.isRunnable) { //now runnable
		//var manager = dijit.byId('app-mgr-ui-id');
		ide._updateAppInfo(this.appId, response.app);					
	  
	    if (ide._statusDialog) {//show informational message
			   ide._statusDialog.showDialog('Info', dojo.string.substitute(this.messages.now_runnable), "");
		}
	  }else{
		var detailResults = response.notRunnableDetail; 	  	
        this.runnableStatus.innerHTML ="";
        this.runnableStatus.scrollTop = this.runnableStatus.scrollHeight;//cleared data, reset the top position		
		
		//add the response data to the html element
		for (var i = 0; i < detailResults.length; i++) {
            this.runnableStatus.innerHTML += detailResults[i] + '<br />';
        }
		if (this.runnableStatus.innerHTML.indexOf("CWPZT0915E:") == -1) {
			//hide the Update dep button
			dojo.style(this.update.domNode, "display", "none");
		} else {
			//show the Update dep button
			dojo.style(this.update.domNode, "display", "");
		}       
		this.show();
	  }
       
      if(zlog.isDebug())console.debug("NotRunnableDialog._handleRunnableDetailsInfo - EXIT" );

    },

    // show error message that was created in the "service"
	_handleNotRunnableError : function (response, ioArgs) {
      if(zlog.isDebug())("NotRunnableDialog._handleNotRunnableError ENTRY/EXIT");    
	  var ide = dijit.byId('app-mgr-ui-id');
      ide.hideProgressDlg();
	  if (this._statusDialog) {
		  this._statusDialog.showDialog('Error', '', eval('(' + ioArgs.xhr.responseText + ')').errorMessage);
	  }
	},


  
    startup: function()
    {
	  if (this._statusDialog === null) {
         this._statusDialog = dijit.byId('status-dialog');
      }
    },
     
    postMixInProperties: function()
    {
        zero.ide.widget.appmgr.NotRunnableDialog.superclass.postMixInProperties.apply(this, arguments);
 	    
		this.messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "CommonAppDialogNls", this.lang);
        
        this._uid = dojox.uuid.generateRandomUuid();
    }, 
	    
    // Dojo event stubs
    dialogClosed: function() {},

    //globals vars 
	resourceString: null,
	baseResourceString: "/resources/applications",
	statusDialog: null,
    notRunnableDialog: null
}
);
}